/* WebMail/2 beta 81 Dimitris 'sehh' Michelinakis <dimitris@michelinakis.gr> */

Globals.!serv=127.0.0.1 /* IP address of the machine running WebManager */
Globals.!port=1924      /* Port that WebManager listens to */
Globals.!WMPath=""      /* Path to .WM files, default is %etc%\webmailhtml\ */
                        /* the ending backslash is required */
Globals.!MaxEmails=10   /* Maximum emails listed per page */
Globals.!CharSet="iso-8859-1" /* Default charater set */
Globals.!TagLine="NO"   /* Experimental tag lines */
Globals.!MaxAttachSize="2097152" /* Max attachment size (2MB default) */

/* WebMail/2 */
parse SOURCE Globals.!myinfo .
if Globals.!myinfo="OS/2" then do
 call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
 call SysLoadFuncs
 call RxFuncAdd 'SockLoadFuncs','RxSock','SockLoadFuncs'
 call SockLoadFuncs(1)
 call RxFuncAdd 'DCLoadFuncs','rxDCplus','DCLoadFuncs'
 call DCLoadFuncs
end; else if Globals.!myinfo="UNIX" then do
 call RxFuncAdd 'SockLoadFuncs','rxsock','SockLoadFuncs'
 call SockLoadFuncs
end
Globals.!myinfo="WebMail/2 for OS/2"
Globals.!myself=translate(value("SCRIPT_NAME",,'ENVIRONMENT'),"/","\")
if Globals.!WMPath="" then Globals.!WMPath=value("ETC",,'ENVIRONMENT')||"\webmailhtml\"
if value("WEBMAIL2_SERV",,'ENVIRONMENT')<>"" then Globals.!serv=value("WEBMAIL2_SERV",,'ENVIRONMENT')
if value("WEBMAIL2_PORT",,'ENVIRONMENT')<>"" then Globals.!port=value("WEBMAIL2_PORT",,'ENVIRONMENT')
if value("WEBMAIL2_PATH",,'ENVIRONMENT')<>"" then Globals.!WMPath=value("WEBMAIL2_PATH",,'ENVIRONMENT')
if value("WEBMAIL2_MAXE",,'ENVIRONMENT')<>"" then Globals.!MaxEmails=value("WEBMAIL2_MAXE",,'ENVIRONMENT')
if value("WEBMAIL2_CHARSET",,'ENVIRONMENT')<>"" then Globals.!CharSet=value("WEBMAIL2_CHARSET",,'ENVIRONMENT')
if value("WEBMAIL2_MAXSIZE",,'ENVIRONMENT')<>"" then Globals.!MaxAttachSize=value("WEBMAIL2_MAXSIZE",,'ENVIRONMENT')
if value("REQUEST_METHOD",,'ENVIRONMENT')="GET" then do
 if pos(Globals.!myself,value("HTTP_REFERER",,'ENVIRONMENT'))<1 then call UserLoginScreen
 Globals.!querystring=URLDecode(value("QUERY_STRING",,'ENVIRONMENT'))
 parse value Globals.!querystring with Globals.!stat1 "&" Globals.!stat2 "&" Globals.!stat3
 if pos("refresh",Globals.!stat1)=1 then call CheckLogon "checkemail"
 else if pos("read",Globals.!stat1)=1 then call CheckLogon "read"
 else if pos("new",Globals.!stat1)=1 then call CheckLogon "new"
 else if pos("delete",Globals.!stat1)=1 then call CheckLogon "delete"
 else if pos("logoff",Globals.!stat1)=1 then call CheckLogon "logoff"
 else if pos("download",Globals.!stat1)=1 then call CheckLogon "download"
 else if pos("help",Globals.!stat1)=1 then call CheckLogon "help"
 else if pos("addr",Globals.!stat1)=1 then call CheckLogon "addr"
 else if pos("sign",Globals.!stat1)=1 then call CheckLogon "sign"
 else if pos("userscr",Globals.!stat1)=1 then call NewUserScreen
end; else do
 Globals.!ContentLength=value("CONTENT_LENGTH",,'ENVIRONMENT')
 if Globals.!ContentLength>0 then Globals.!querystring=charin(,,Globals.!ContentLength)
 Globals.!ContentType=value("CONTENT_TYPE",,'ENVIRONMENT')
 if pos("multipart/form-data",Globals.!ContentType)>0 then do
  if pos(Globals.!myself,value("HTTP_REFERER",,'ENVIRONMENT'))<1 then call UserLoginScreen
  Globals.!stat1="postnew"
  call CheckLogon "postnew"
 end; else do
  Globals.!querystring=URLDecode(Globals.!querystring)
  parse value Globals.!querystring with Globals.!stat1 "&" Globals.!stat2 "&" Globals.!stat3
  if pos("flogin=",Globals.!stat1)=1 then call CheckLogon "fcheckemail"
  if pos("userreg=",Globals.!stat1)=1 then call NewUser
  if pos("addressbadd=",Globals.!stat1)=1 then call CheckLogon "addr"
  if pos("signaturesave=",Globals.!stat1)=1 then call CheckLogon "sign"
 end
end
call UserLoginScreen
return

AddrScreen: procedure expose Globals.
Globals.!ServerErr=""
Globals.!AddrAlias=""
Globals.!AddrName=""
Globals.!AddrEmail=""
if Globals.!stat1="addressbadd=1" then do
 parse value Globals.!querystring with . "&returnto=" Globals.!stat2 "&a=" Globals.!AddrAlias "&n=" Globals.!AddrName "&e=" Globals.!AddrEmail
 if pos(":",Globals.!AddrAlias)>0 then Globals.!ServerErr="Invalid characters detected"
 else if pos("@",Globals.!AddrEmail)<1 then Globals.!ServerErr="Invalid email address"
 else if Globals.!AddrAlias=""&Globals.!AddrName="" then Globals.!ServerErr="The alias and name fields are both incomplete"
 else if Globals.!AddrEmail="" then Globals.!ServerErr="Email field is incomplete"
 else do
  call ConnectManager
  Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
  if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
  cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
  call SendData "6:"||cookie||":"||Globals.!clientIP||":"||Globals.!AddrAlias||":"||Globals.!AddrName||":"||Globals.!AddrEmail||":"||'0d0a'x
  call ReceiveData
  if substr(newData,1,1)=1 then Globals.!ServerErr="User added successfully"
  else if substr(newData,1,1)=3 then Globals.!ServerErr="Alias already exists"
  else if substr(newData,1,1)=2 then Globals.!ServerErr="Name already exists"
  else if substr(newData,1,1)=4 then Globals.!ServerErr="Email address already exists"
 end
 if Globals.!stat2>0 then do
  Globals.!stat3=""
  call ReceiveEmail
 end
 Globals.!stat2="a"
 Globals.!stat3=""
end
if Globals.!stat2="a" then do
 i=0
 if Globals.!stat3<>"" then do
  parse value Globals.!stat3 with i "&" Globals.!stat3
  Globals.!stat3=RXB64decode(Globals.!stat3)
  if pos(" ",Globals.!stat3)>0 then do
   Globals.!AddrEmail=substr(Globals.!stat3,lastpos(" ",Globals.!stat3)+1)
   Globals.!AddrName=substr(Globals.!stat3,1,lastpos(" ",Globals.!stat3)-1)
  end; else Globals.!AddrEmail=Globals.!stat3
  if pos("<",Globals.!AddrEmail)>0 then Globals.!AddrEmail=translate(Globals.!AddrEmail,"","<")
  if pos(">",Globals.!AddrEmail)>0 then Globals.!AddrEmail=translate(Globals.!AddrEmail,"",">")
  Globals.!AddrEmail=space(Globals.!AddrEmail)
  if pos('"',Globals.!AddrName)>0 then Globals.!AddrName=space(translate(Globals.!AddrName,"",'"'))
  if pos("=?",Globals.!AddrName)=1 then do
   parse value Globals.!AddrName with . "?" . "?" . "?" Globals.!AddrName "?" .
   Globals.!AddrName=RXdeQuoted(Globals.!AddrName)
  end
 end
 call ParseHTML Globals.!WMPath||"header.wm",1
 call ParseHTML Globals.!WMPath||"addressb-add.wm"
 call ParseHTML Globals.!WMPath||"footer.wm"
 exit
end
if Globals.!stat2="d" then do
 call ConnectManager
 Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
 if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
 cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
 call SendData "7:"||cookie||":"||Globals.!clientIP||":"||Globals.!stat3||":"||'0d0a'x
 call ReceiveData
 if substr(newData,1,1)=1 then Globals.!ServerErr="Removed email "||Globals.!stat3
 else if substr(newData,1,1)=2 then Globals.!ServerErr="Couldn't remove email "||Globals.!stat3
end
call ConnectManager
Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
call SendData "5:"||cookie||":"||Globals.!clientIP||":"||'0d0a'x
call ReceiveDataExtended 32768
book=newData
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 1,"CheckLogon: Error on SockSoClose"
if ARG(1)=1 then return book
call ParseHTML Globals.!WMPath||"header.wm",1
Globals.!AddrTable=""
if pos(":",book)>0 then do
 do while pos(":",book)>0
  parse value book with Globals.!AddrAlias ":" Globals.!AddrName ":" Globals.!AddrEmail '0d0a'x book
  Globals.!AddrTable=Globals.!AddrTable||ParseHTML(Globals.!WMPath||"addressb-table.wm",0,1)
 end
end
call ParseHTML Globals.!WMPath||"addressb.wm"
call ParseHTML Globals.!WMPath||"footer.wm"
exit

CheckEmail: procedure expose Globals.
call ConnectPOP
call SendData "STAT"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"CheckEmail: Email server couldn't get status"
end
parse value newData with . Globals.!totalmail Globals.!totalsize
if datatype(Globals.!totalmail,"N")<>1 then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"CheckEmail: Server returned wrong value"
end
jumpnumber=0
Globals.!JumpTable=""
if Globals.!totalmail>Globals.!MaxEmails then do
 jumpnumber=Globals.!totalmail / Globals.!MaxEmails
 if pos(".",jumpnumber)>0 then jumpnumber=substr(jumpnumber,1,pos(".",jumpnumber)-1)+1
 do zz=1 to jumpnumber
  if zz=Globals.!stat2 then iterate
  Globals.!JumpPage=zz
  Globals.!JumpTable=Globals.!JumpTable||ParseHTML( Globals.!WMPath||"jump-table.wm",0,1 )
 end
end
if Globals.!stat2<=jumpnumber & Globals.!totalmail>=1 then do
 Globals.!SetCookiePage=Globals.!stat2
 zz=Globals.!stat2 * Globals.!MaxEmails
 EmailStart=zz - Globals.!MaxEmails + 1
 if zz>Globals.!totalmail then zz=Globals.!totalmail
 Globals.!totalmail=zz
end; else if Globals.!totalmail>=1 then do
 Globals.!SetCookiePage=1
 if Globals.!totalmail>Globals.!MaxEmails then Globals.!totalmail=Globals.!MaxEmails
 EmailStart=1
end; else EmailStart=0
zz=0
if Globals.!totalmail>0 then do
 do i=EmailStart to Globals.!totalmail
  call SendData "TOP "||i||" 0"||'0d0a'x
  call ReceiveData 3
  if substr(newData,1,3)="+OK" then do
    call ReceiveDataExtended 32768
    oldData=newData
   zz=zz+1
   ListMail.i.!h=oldData
  end
 end
end
ListMail.0=zz
call SendData "QUIT"||'0d0a'x
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 3,"CheckEmail: Error on SockSoClose"
call ParseHTML Globals.!WMPath||"header.wm",1
if ListMail.0>0 then do
 Globals.!ListTable=""
 do i=EmailStart to Globals.!totalmail
  call ScanHeaders 1
  if ListMail.i.!ContentType="YES" then Globals.!ContentType=ParseHTML(Globals.!WMPath||"attachment-yes.wm",0,1)
  else Globals.!ContentType=ParseHTML(Globals.!WMPath||"attachment-no.wm",0,1)
  if ListMail.i.!Priority="High" then Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-high.wm",0,1)
  else do
   if ListMail.i.!Priority="Low" then Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-low.wm",0,1)
   else Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-normal.wm",0,1)
  end 
  Globals.!ListTable=Globals.!ListTable||ParseHTML(Globals.!WMPath||"listemails-table.wm",0,1)
 end
 call ParseHTML Globals.!WMPath||"listemails.wm"
end; else call ParseHTML Globals.!WMPath||"nomail.wm"
call ParseHTML Globals.!WMPath||"footer.wm"
exit

CheckLogon: procedure expose Globals.
Globals.!ServerErr=""
Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
if ARG(1)="fcheckemail" then tmp1=0
else if ARG(1)="logoff" then tmp1=2
else tmp1=1
Globals.!Cookie=value("HTTP_COOKIE",,'ENVIRONMENT')
if tmp1<>0&pos("WEBMAIL2",Globals.!Cookie)<1 then do
 call SysSleep 6
 call ErrorScreen 1,"Login refused"
end
call ConnectManager
if tmp1=0 then do
 Globals.!user=substr(Globals.!stat2,3,length(Globals.!stat2)-2)
 Globals.!pazz=substr(Globals.!stat3,3,length(Globals.!stat3)-2)
 call SendData tmp1||":"||Globals.!user||":"||Globals.!pazz||":"||Globals.!clientIP||":"||'0d0a'x
end; else do
 cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
 call SendData tmp1||":"||cookie||":"||Globals.!clientIP||":"||'0d0a'x
end
if tmp1<>2 then do
 call ReceiveData
 rc=SockSoClose(socket)
 if rc=-1 then call ErrorScreen 1,"CheckLogon: Error on SockSoClose"
 if pos("[WebManager2] OK",newData)<1 then do
  call SysSleep 6
  call ErrorScreen 1,"Login refused"
 end
 parse value newData with . ":" Globals.!pop3 ":" Globals.!pop3p ":" Globals.!smtp ":" Globals.!smtpp ":" Globals.!AuthID ":" Globals.!user ":" Globals.!pazz ":" Globals.!realname ":"
 if ARG(1)="fcheckemail" then do
  Globals.!SetCookie="SET"
  Globals.!SetCookiePage=1
  Globals.!stat2=1
  Globals.!stat3=""
  call CheckEmail
 end; else if ARG(1)="checkemail" then call CheckEmail
 else if ARG(1)="read" then call ReceiveEmail
 else if ARG(1)="new" then call NewEmailScreen
 else if ARG(1)="postnew" then call NewEmail
 else if ARG(1)="delete" then call DeleteEmail
 else if ARG(1)="download" then call Download
 else if ARG(1)="help" then call HelpScreen
 else if ARG(1)="addr" then call AddrScreen
 else if ARG(1)="sign" then call SignScreen
end; else call UserLoginScreen
call SysSleep 6
call ErrorScreen 1,"Login refused"
return

ConnectManager: procedure expose Globals. socket newData
socket=SockSocket("AF_INET","SOCK_STREAM",0)
if socket=-1 then call ErrorScreen 1,"CheckLogon: Error open socket"
call SockSetSockOpt socket,"SOL_SOCKET","SO_RCVTIMEO",10
call SockSetSockOpt socket,"SOL_SOCKET","SO_SNDTIMEO",10
server.!family="AF_INET"
server.!port=Globals.!port
server.!addr=Globals.!serv
rc=SockConnect(socket,"server.!")
if rc=-1 then call ErrorScreen 1,"CheckLogon: Error on Socket/Port connection"
return

ConnectPOP: procedure expose Globals. socket
socket=SockSocket("AF_INET","SOCK_STREAM",0)
if socket=-1 then call ErrorScreen 3,"ConnectPOP: Error open socket"
call SockSetSockOpt socket,"SOL_SOCKET","SO_RCVTIMEO",10
call SockSetSockOpt socket,"SOL_SOCKET","SO_SNDTIMEO",10
server.!family="AF_INET"
server.!port=Globals.!pop3p
server.!addr=Globals.!pop3
rc=SockConnect(socket,"server.!")
if rc=-1 then call ErrorScreen 3,"ConnectPOP: Error on Socket/Port connection"
call ReceiveData
if substr(newData,1,3)<>"+OK" then call ErrorScreen 2,"ConnectPOP: Server refused connection"
if right(Globals.!AuthID,1)=0 then parse value Globals.!user with tmpuser "@" tmpdomain
else tmpuser=Globals.!user
call SendData "USER "||tmpuser||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ConnectPOP: Server refused user login"
end
call SendData "PASS "||Globals.!pazz||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ConnectPOP: Failed login, your account is locked, retry later."
end
return

DeleteEmail: procedure expose Globals.
call ConnectPOP
if pos("all",Globals.!stat2)>0 then do
 call SendData "STAT"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"DeleteEmail: Email server couldn't get status"
 end
 parse value newData with . Globals.!totalmail .
 if datatype(Globals.!totalmail,"N")<>1 then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"DeleteEmail: Server returned wrong value"
 end
 do i=1 to Globals.!totalmail
  call SendData "DELE "||i||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"+OK" then do
   call SendData "QUIT"||'0d0a'x
   call ErrorScreen 2,"DeleteEmail: Server couldn't delete email or email already deleted"
  end
 end
end; else do
 call SendData "DELE "||Globals.!stat2||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"+OK" then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"DeleteEmail: Server couldn't delete email or email already deleted"
 end
end
call SendData "QUIT"||'0d0a'x
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 3,"DeleteEmail: Error on SockSoClose"
say "Status: 301 Moved Permanently"
if Globals.!stat3<>"" then do
 Globals.!stat2=Globals.!stat3-1
 if Globals.!stat2=0 then say 'Location: '||Globals.!myself||"?refresh&1"
 else if Globals.!stat2=-1 then say 'Location: '||Globals.!myself||"?refresh&1"
 else say 'Location: '||Globals.!myself||"?read&"||Globals.!stat2
end; else do
 if pos("WEBMAIL2PAGE=",Globals.!Cookie)>0 then do
  Globals.!stat2=substr(Globals.!Cookie,pos("WEBMAIL2PAGE=",Globals.!Cookie)+13)
  say 'Location: '||Globals.!myself||"?refresh&"||Globals.!stat2
 end; else say 'Location: '||Globals.!myself||"?refresh"
end
say "Cache-Control: private"
say "Pragma: no-cache"
say "Expires: NOW"
say ""
exit

Download: procedure expose Globals.
parse value Globals.!stat2 with Globals.!stat2 ":" FileName
if FileName="unknown" then call ErrorScreen 2,"Download: Unknown file attachment"
call ReceiveEmail 4
ListMail.i.!h=translate(ListMail.i.!h," ",'09'x)
poz=pos('0d0a'x,ListMail.i.!h)+2
do while poz<length(ListMail.i.!h)
 rc=substr(ListMail.i.!h,poz,1)
 if rc=" " then ListMail.i.!h=substr(ListMail.i.!h,1,poz-3)||" "||space(substr(ListMail.i.!h,poz+1))
 poz=pos('0d0a'x,ListMail.i.!h,poz)+2
end
h1=translate(ListMail.i.!h)
if pos("CONTENT-TYPE:",h1)>0 then do
 tmp1=pos("CONTENT-TYPE:",h1)+13
 tmp2=pos('0d0a'x,h1,tmp1)
 tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
 if pos("MULTIPART/MIXED;",translate(tmp3))>0 then do
  boundary=substr(tmp3,pos("BOUNDARY=",translate(tmp3))+9)
  if pos('"',boundary)=1 then boundary=substr(boundary,2,length(boundary)-2)
  boundary="--"||boundary
  pozlength=1
  zi=0
  do while pos(boundary||'0d0a'x,ListMail.i.!b,pozlength)>0
   poz=pos(boundary||'0d0a'x,ListMail.i.!b,pozlength)
   pozlength=pos('0d0a'x||'0d0a'x,ListMail.i.!b,poz)+4
   headerz=substr(ListMail.i.!b,poz,pozlength-poz)
   if pos(FileName,headerz)>0&pos("BASE64",translate(headerz))>0 then do
    pozlength2=pos(boundary,ListMail.i.!b,pozlength)
    ListMail.i.!b=substr(ListMail.i.!b,pozlength,pozlength2-pozlength)
    say 'Content-Type: application/octet-stream'
    say 'Content-Disposition: attachment; filename="'||FileName||'"'
    say 'Content-Length: '||length(ListMail.i.!b)
    say "Cache-Control: private"
    say "Pragma: no-cache"
    say ""
    call charout ,RXB64decode(ListMail.i.!b)
    exit
   end
  end
 end; else call ErrorScreen 2,"Download: Unknown file attachment"
end; else call ErrorScreen 2,"Download: Unknown file attachment"
exit

ErrorScreen: procedure expose Globals.
Globals.!ServerErr=ARG(2)
if ARG(1)=1 then do
 Globals.!SetCookie="SET"
 Globals.!AuthID=""
 call ParseHTML Globals.!WMPath||"loginerror.wm",1
end; else if ARG(1)=2 then do
 call ParseHTML Globals.!WMPath||"header.wm",1
 call ParseHTML Globals.!WMPath||"servererror.wm"
 call ParseHTML Globals.!WMPath||"footer.wm"
end; else if ARG(1)=3 then do
 socket=SockSocket("AF_INET","SOCK_STREAM",0)
 call SockSetSockOpt socket,"SOL_SOCKET","SO_RCVTIMEO",10
 call SockSetSockOpt socket,"SOL_SOCKET","SO_SNDTIMEO",10
 server.!family="AF_INET"
 server.!port=Globals.!port
 server.!addr=Globals.!serv
 call SockConnect socket,"server.!"
 call SockSend socket,"3:"||ARG(2)
 call SockSoClose socket
 call ErrorScreen 2,"Email Server Error!"
end
exit

HelpScreen: procedure expose Globals.
call ParseHTML Globals.!WMPath||"header.wm",1
call ParseHTML Globals.!WMPath||"help.wm"
call ParseHTML Globals.!WMPath||"footer.wm"
exit

Html2Txt: procedure
html=ARG(1)
chars.1="<"
chars.2=">"
chars.3="&"
chars.4=";"
chars.0=4
do i=1 to chars.0
 z=i+1
 tmp1=1
 do while tmp1>0
  tmp1=pos(chars.i,html,tmp1)
  if tmp1<1 then leave
  tmp2=pos(chars.z,html,tmp1)
  if tmp2<tmp1 then leave
  html=delstr(html,tmp1,tmp2-tmp1+1)
 end
 i=i+1
end
return html

NewEmail: procedure expose Globals.
parse value Globals.!ContentType with . "boundary=" boundary
if pos('"',boundary)=1 then boundary=substr(boundary,2,length(boundary)-2)
boundary='0d0a'x||"--"||boundary
sendto=""
replysel1=""
replyto=""
replysel2=""
ccto=""
bccto=""
subject=""
epriority="Normal"
body=""
filename=""
eol='0d0a'x||'0d0a'x
do 11
 parse value Globals.!querystring with headbody (eol) Globals.!querystring
 if headbody="" then iterate
 else headbody=headbody||'0d0a'x
 poz=pos("CONTENT-DISPOSITION:",translate(headbody))
 if poz<1 then iterate
 pozend=pos('0d0a'x,headbody,poz)
 headval=substr(headbody,poz,pozend-poz)
 if pos("FORM-DATA",translate(headval))<1 then iterate
 if pos("NAME=",translate(headval))<1 then iterate
 headval=substr(headval,pos("NAME=",translate(headval))+5)
 if pos('"',headval)=1 then headval=substr(headval,2,pos('"',headval,2)-2)
 if headval="" then call ErrorScreen 3,"NewEmail: Error reading form while posting email"
 if headval<>"upload_file" then parse value Globals.!querystring with bodyval (boundary) Globals.!querystring
 if headval="t" then sendto=bodyval
 else if headval="charset" then charset=bodyval
 else if headval="rb" then replysel1=bodyval
 else if headval="rt" then replyto=bodyval
 else if headval="rb2" then replysel2=bodyval
 else if headval="c" then ccto=bodyval
 else if headval="b" then bccto=bodyval
 else if headval="s" then subject=bodyval
 else if headval="p" then epriority=bodyval
 else if headval="body" then body=bodyval
 else if headval="upload_file" then do
  headval=substr(headbody,poz,pozend-poz)
  if pos("FILENAME=",translate(headval))<1 then iterate
  headval=substr(headval,pos("FILENAME=",translate(headval))+9)
  if pos('"',headval)=1 then headval=substr(headval,2,pos('"',headval,2)-2)
  if headval<>"" then do
   filename=filespec("name",headval)
   parse value Globals.!querystring with Globals.!querystring (boundary) .
   leave
  end
 end
end
if replysel1="f"&replysel2="" then nop
else if replysel1=""&replysel2="r" then sendto=replyto
else if replysel1="f"&replysel2="r" then sendto=sendto||" "||replyto
else call ErrorScreen 2,"NewEmail: You must select atleast one email target"
if filename<>""&length(Globals.!querystring)>Globals.!MaxAttachSize then call ErrorScreen 2,"NewEmail: Attachment size exceeds the limit of "||format(Globals.!MaxAttachSize/1048576,,1)||" MB"
sendto=ResolveEmails(sendto)
if ccto<>"" then ccto=ResolveEmails(ccto)
if bccto<>"" then bccto=ResolveEmails(bccto)
socket=SockSocket("AF_INET","SOCK_STREAM",0)
if socket=-1 then call ErrorScreen 3,"NewEmail: Error open socket"
call SockSetSockOpt socket,"SOL_SOCKET","SO_RCVTIMEO",10
call SockSetSockOpt socket,"SOL_SOCKET","SO_SNDTIMEO",10
server.!family="AF_INET"
server.!port=Globals.!smtpp
server.!addr=Globals.!smtp
rc=SockConnect(socket,"server.!")
if rc=-1 then call ErrorScreen 3,"NewEmail: Error on Socket/Port connection"
call ReceiveData
if substr(newData,1,3)<>"220" then call ErrorScreen 2,"NewEmail: Server refused connection"
do while substr(newData,4,1)<>" "
 call ReceiveData
end
call SendData "HELO "||Globals.!clientIP||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"NewEmail: Server dropped connection"
end
call SendData "MAIL FROM: <"||Globals.!user||">"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"NewEmail: Server rejected email transfer"
end
if pos(" ",sendto)>0 then do
 tmp=sendto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ErrorScreen 2,"NewEmail: Server rejected target email:"||newData
  end
 end
end; else do
 call SendData "RCPT TO: <"||sendto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"NewEmail: Server rejected target email:"||newData
 end
end
if pos(" ",ccto)>0 then do
 tmp=ccto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ErrorScreen 2,"NewEmail: Server rejected target email"
  end
 end
end; else if ccto<>"" then do
 call SendData "RCPT TO: <"||ccto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"NewEmail: Server rejected target email"
 end
end
if pos(" ",bccto)>0 then do
 tmp=bccto
 do while tmp<>""
  parse value tmp with sendto1 tmp
  call SendData "RCPT TO: <"||sendto1||">"||'0d0a'x
  call ReceiveData
  if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
   call SendData "QUIT"||'0d0a'x
   call ErrorScreen 2,"NewEmail: Server rejected target email"
  end
 end
end; else if bccto<>"" then do
 call SendData "RCPT TO: <"||bccto||">"||'0d0a'x
 call ReceiveData
 if substr(newData,1,3)<>"250" & substr(newData,1,3)<>"251" then do
  call SendData "QUIT"||'0d0a'x
  call ErrorScreen 2,"NewEmail: Server rejected target email"
 end
end
call SendData "DATA"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"354" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"NewEmail: Server rejected email data"
end
if Globals.!realname="" then header="From: <"||Globals.!user||">"||'0d0a'x
else header='From: "'||Globals.!realname||'" <'||Globals.!user||">"||'0d0a'x
if pos(" ",sendto)>0 then do
 tmp=sendto
 parse value tmp with sendto1 tmp
 header=header||"To: <"||sendto1||">,"||'0d0a'x
 do while tmp<>""
  parse value tmp with sendto1 tmp
  header=header||"    <"||sendto1||">"
  if tmp<>"" then header=header||","||'0d0a'x
  else header=header||'0d0a'x
 end
end; else header=header||"To: <"||sendto||">"||'0d0a'x
if pos(" ",ccto)>0 then do
 tmp=ccto
 parse value tmp with sendto1 tmp
 header=header||"Cc: <"||sendto1||">,"||'0d0a'x
 do while tmp<>""
  parse value tmp with sendto1 tmp
  header=header||"    <"||sendto1||">"
  if tmp<>"" then header=header||","||'0d0a'x
  else header=header||'0d0a'x
 end
end; else if ccto<>"" then header=header||"Cc: <"||ccto||">"||'0d0a'x
tz=value("TZ",,'ENVIRONMENT')
if pos(",",tz)>0 then tz=substr(tz,1,pos(",",tz)-1)
header=header||"Date: "||substr(date("W"),1,3)||", "||date('N')||" "||time()||" "||tz||'0d0a'x
header=header||"Priority: "||epriority||'0d0a'x
header=header||"X-Mailer: "||Globals.!myinfo||'0d0a'x
header=header||"MIME-Version: 1.0"||'0d0a'x
if filename="" then header=header||"Content-Type: text/plain; charset="||charset||'0d0a'x
else do
 boundary="_=_=_=WBM.BOUNDARY."||date("B")||random()||"=_=_=_"
 header=header||'Content-Type: multipart/mixed; boundary="'||boundary||'"'||'0d0a'x
end
header=header||"Subject: "||subject||'0d0a'x||'0d0a'x
if filename="" then body=header||body
else do
 body=header||"--"||boundary||'0d0a'x||"Content-Type: text/plain; charset="||charset||'0d0a'x||"Content-Transfer-Encoding: 8bit"||'0d0a'x||'0d0a'x||body||'0d0a'x||"--"||boundary||'0d0a'x||'Content-Type: application/octet-stream; name="'||filename||'"'||'0d0a'x||"Content-Transfer-Encoding: base64"||'0d0a'x||'Content-Disposition: attachment; filename="'||filename||'"'||'0d0a'x||'0d0a'x
end
call SendData body
if filename<>"" then do
 buf=RXB64encode(Globals.!querystring)
 poz=1
 do while poz<length(buf)
  if (poz+32768)<length(buf) then call SendData substr(buf,poz,32768)
  else call SendData substr(buf,poz,length(buf)-poz+1)
  poz=poz+32768
 end
 call SendData '0d0a'x||"--"||boundary||"--"
end
call SendData '0d0a'x||"."||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"250" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"NewEmail: Server rejected email data"
end
call SendData "QUIT"||'0d0a'x
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 3,"NewEmail: Error on SockSoClose"
if pos("WEBMAIL2PAGE=",Globals.!Cookie)>0 then do
 Globals.!stat2=substr(Globals.!Cookie,pos("WEBMAIL2PAGE=",Globals.!Cookie)+13)
 Globals.!stat3=""
end
call CheckEmail
return

NewEmailScreen: procedure expose Globals.
Globals.!EmailReplyTo=""
if Globals.!stat2<>"" then call ReceiveEmail 3
else do
 ListMail.i.!From=""
 ListMail.i.!Cc=""
 ListMail.i.!Subject=""
 ListMail.i.!b=""
end
rc=SignScreen(1)
if rc<>"" then ListMail.i.!b=ListMail.i.!b||'0d0a'x||'0d0a'x||rc
if Globals.!TagLine="YES" then do
tagline.0=192
tagline.1="<> God created men and rested... God created women and no-ones rested since!"
tagline.2="<> God is my co-pilot, but the Devil is my bombardier."
tagline.3="<> God may have made man first, but there is always a rough draft before a final copy."
tagline.4="<> God must love stupid people, he made so many."
tagline.5="<> Good girls get fat, bad girls get eaten."
tagline.6="<> Gravity doesn't exist. Earth sucks. "
tagline.7="<> Ground Beef: A Cow With No Legs!"
tagline.8="<> Growing old is mandatory; growing up is optional!! "
tagline.9="<> Guests who kill talk show hosts--On the last Geraldo."
tagline.10="<> Guns don't kill people, postal workers do."
tagline.11="<> H lp! S m b dy  st ll th  v wl s fr m my k yb  rd!"
tagline.12="<> Half of the people in the world are below average. "
tagline.13="<> Half the people you know are below average."
tagline.14="<> Hang up and drive!"
tagline.15="<> Happiness is a belt-fed weapon."
tagline.16="<> Hard work pays off in the future. Laziness pays off now."
tagline.17="<> Harder than your husband!!"
tagline.18="<> hAS ANYONE SEEN MY cAPSLOCK KEY? "
tagline.19="<> Having a Smoking Section in a restaurant is a little like having a Peeing Section in a pool."
tagline.20="<> He who hesitates is probably right."
tagline.21="<> He who laughs last has the best lawyer"
tagline.22="<> He who laughs last thinks slowest! "
tagline.23="<> Heaven won't have me and Hell's afraid I'll take over. "
tagline.24="<> Hell hath no fury like the lawyer of a woman scorned."
tagline.25="<> Help nature, don't breathe."
tagline.26="<> Help stamp out and eradicate superfluous redundancy."
tagline.27="<> Help Wanted: Telepath. You know where to apply."
tagline.28="<> Help! My Reality Check Bounced!"
tagline.29="<> Here I am! Now what are your other two wishes?"
tagline.30="<> Hi-ho, hi-ho, it's hand grenades I throw..."
tagline.31="<> Hold a hard drive to your ear -- listen to the C: "
tagline.32="<> Hold the Liberals liable"
tagline.33="<> Horn broken, watch for finger."
tagline.34="<> House guarded by SHOTGUN 3 nights a week. You guess which 3."
tagline.35="<> How can I miss you if you won't go away?"
tagline.36="<> How can my checking account be overdrawn? I still have checks!"
tagline.37="<> How come abbreviated is such a long word?"
tagline.38="<> How come Superman could stop bullets with his chest, but always ducked when someone threw a gun at him?"
tagline.39="<> How do I set a laser printer to stun?"
tagline.40="<> How do most men define marriage? A very expensive way to get your laundry done free."
tagline.41="<> How do you tell when you've run out of invisible ink?"
tagline.42="<> How many of you believe in telekinesis? Raise my hands...."
tagline.43="<> How many times do I have to flush before you go away?"
tagline.44="<> I almost had a psychic girlfriend but she left me before we met."
tagline.45="<> I am built for comfort, not for speed!"
tagline.46="<> I am logged in, therefore I am."
tagline.47="<> I am only horny on the days that end in y."
tagline.48="<> I believe no problem is so large or so difficult that it can't be fixed with the right amount of C4!"
tagline.49="<> I brake just for the hell of it!"
tagline.50="<> I can please only one person per day.  Today is not your day.  Tomorrow isn't looking good either."
tagline.51="<> I can see clearly now, the brain is gone..."
tagline.52="<> I can't remember if I'm the good twin or the evil one."
tagline.53="<> I couldn't repair your brakes, so I made your horn louder."
tagline.54="<> I did a drot of lugs in college, I hink I thave dain bramage. "
tagline.55="<> I did alot of drugs in the 50's now I do them at room temperature."
tagline.56="<> I didn't fight my way to the top of the food chain to be a vegetarian."
tagline.57="<> I don't care who you are, FATSO. Get the reindeer off my roof!"
tagline.58="<> I don't care, I don't have to."
tagline.59="<> I don't find it hard to meet expenses. They're everywhere!"
tagline.60="<> I don't have a license to kill.  I have a learner's permit."
tagline.61="<> I don't have a solution but I admire the problem."
tagline.62="<> I don't have an attitude problem.  You have a perception problem."
tagline.63="<> I don't have to be dead to donate my organ."
tagline.64="<> I don't suffer from insanity. I enjoy every minute of it. "
tagline.65="<> I don't suffer from stress.  I'm a carrier."
tagline.66="<> I drive way too fast to worry about cholesterol."
tagline.67="<> I failed my urine-test."
tagline.68="<> I feel like I'm diagonally parked in a parallel universe."
tagline.69="<> I get enough exercise just pushing my luck"
tagline.70="<> I got a gun for my wife, best trade I ever made."
tagline.71="<> I got some diving equipment for my wife... It was the best trade I ever made."
tagline.72="<> I had a life once... now I have a computer and a modem. "
tagline.73="<> I had a monumental idea this morning, but I didn't like it."
tagline.74="<> I have the heart of a child. I keep it in a jar. "
tagline.75="<> I intend to live forever - so far, so good."
tagline.76="<> I just want revenge. Is that so wrong?"
tagline.77="<> I killed a 6-pack just to watch it die."
tagline.78="<> I know what you're thinking, and you should be ashamed of yourself."
tagline.79="<> I let my mind wander and it didn't come back."
tagline.80="<> I like cats, too. Let's exchange recipes."
tagline.81="<> I like you, but I wouldn't want to see you working with subatomic particles"
tagline.82="<> I loathe people who keep dogs.  They are cowards who haven't got the guts to bite people themselves."
tagline.83="<> I love animals... they're delicious."
tagline.84="<> I love cats ... they taste just like chicken"
tagline.85="<> I love cats... dead ones"
tagline.86="<> I love deadlines.  I especially like the whooshing sound they make as they go flying by."
tagline.87="<> I love defenseless animals, especially in a good gravy."
tagline.88="<> I love Jesus.  It's his fan club that makes me nervous."
tagline.89="<> I majored in liberal arts. Will that be for here or to go?"
tagline.90="<> I may be fat, but your ugly - I can lose weight!   "
tagline.91="<> I may be going slow, but I am ahead of you!"
tagline.92="<> I need someone really bad... Are you really bad?"
tagline.93="<> I plead contemporary insanity."
tagline.94="<> I poured Spot remover on my dog. Now he's gone."
tagline.95="<> I pretend to work. They pretend to pay me."
tagline.96="<> I refuse to star in your psychodrama."
tagline.97="<> I said 'no' to drugs, but they just wouldn't listen."
tagline.98="<> I smile because I do not know what is going on."
tagline.99="<> I souport publik edekashun."
tagline.100="<> I started out with nothing &amp; still have most of it left."
tagline.101="<> I still miss my Ex, but my aim is getting better!"
tagline.102="<> I support the three basic food groups.. KEG - BOTTLE - CAN"
tagline.103="<> I think, therefore I am DANGEROUS."
tagline.104="<> I think, therefore I am. I think. "
tagline.105="<> I thought I wanted a career, turns out I just wanted paychecks."
tagline.106="<> I took an IQ test and the results were negative."
tagline.107="<> I tried sniffing Coke once, but the ice cubes got stuck in my nose."
tagline.108="<> I tried switching to gum but I couldn't keep it lit. "
tagline.109="<> I tried to think but nothing happened! - CURLY"
tagline.110="<> I used to be indecisive; now I'm not sure."
tagline.111="<> I used to have a handle on life, but it broke."
tagline.112="<> I used to have an open mind but my brains kept falling out."
tagline.113="<> I used up all my sick days, so I'm calling in dead."
tagline.114="<> I want to die peacefully, in my sleep, like my grandfather, not screaming and terrified, like his passengers. "
tagline.115="<> I wasn't born a bitch.  Men like you made me this way."
tagline.116="<> I went fishing with Salvador Dali; he was using a dotted line."
tagline.117="<> I wonder how much deeper would the ocean be without sponges."
tagline.118="<> I won't rise to the occasion, but I'll slide over to it."
tagline.119="<> I work 40 hours a week to be this poor."
tagline.120="<> I wouldn't be caught dead with a necrophiliac."
tagline.121="<> Winning isn't everything, it's also important to humiliate your opponent"
tagline.122="<> Witches are crafty people"
tagline.123="<> Women who seek to be equal to men lack ambition. "
tagline.124="<> Work is for people who don't know how to fish."
tagline.125="<> Workaholics Anonymous---- THANK GOD IT'S MONDAY"
tagline.126="<> You can listen to thunder and tell how close you came to getting hit. If you don't hear it, you got hit, so never mind.."
tagline.127="<> You can tune a guitar, but you can't tuna fish."
tagline.128="<> You can't be first, but you could be next"
tagline.129="<> You can't have everything...where would you put it? "
tagline.130="<> You have the right to remain silent. Anything you say will be misquoted and used against you."
tagline.131="<> You never really learn to swear until you learn to drive."
tagline.132="<> You say I'm a bitch like it's a bad thing."
tagline.133="<> You show the sensitivity of a Medieval Dentist."
tagline.134="<> You will get what's coming to you....Unless they mailed it."
tagline.135="<> You! Off my planet!"
tagline.136="<> Your kid may be an honor student, but you're still an idiot."
tagline.137="<> Your only young once; you can be immature forever."
tagline.138="<> Your tits look like they're made of cardboard. Are they real?"
tagline.139="<> Your ugly and your mama dresses you funny"
tagline.140="<> You're just jealous because the voices only talk to me."
tagline.141="<> You're only young once; you can be immature forever "
tagline.142="<> You're slower than a herd of turtles stampeding through peanut butter."
tagline.143="<> Make it idiot-proof and someone will make a better idiot."
tagline.144="<> MAKE LOVE NOT WAR - see driver for details"
tagline.145="<> Make the World a better place, kill yourself."
tagline.146="<> Make yourself at home! Clean my kitchen."
tagline.147="<> Many people quit looking for work when they find a job."
tagline.148="<> Marriage is not a word: it is a sentence."
tagline.149="<> Marriage is not a word: its a SENTENCE."
tagline.150="<> Master Baiters catch more fish"
tagline.151="<> Me You Dinner Motel"
tagline.152="<> Mean people rule!"
tagline.153="<> Mean people suck... Nice people swallow..."
tagline.154="<> Meandering to a different drummer."
tagline.155="<> Meat is yummy!"
tagline.156="<> Men who have pierced ears are better prepared for marriage. They've experienced pain and bought jewelry."
tagline.157="<> Mental backup in progress - Do Not Disturb."
tagline.158="<> Mental Floss prevents Moral Decay."
tagline.159="<> Microbiology Lab: Staph Only!"
tagline.160="<> Missing your cat? Try looking under my tires."
tagline.161="<> Monday is an awful way to spend 1/7th of your life."
tagline.162="<> Money can't buy love. But it CAN rent a very close imitation."
tagline.163="<> Montana -- At least the cows are sane!"
tagline.164="<> Mushrooms always grow in damp places, which is why they look like umbrellas."
tagline.165="<> My disgust with the current administration cannot be summarized here."
tagline.166="<> My Karma ran over my Dogma."
tagline.167="<> My kid beat up your honor student."
tagline.168="<> My kid had sex with your honor student."
tagline.169="<> My message above. Your response here ____________. "
tagline.170="<> My other car is a piece of crap too!"
tagline.171="<> My other car is also a Mercedes."
tagline.172="<> My reality check just bounced."
tagline.173="<> My wife keeps complaining I never listen to her ... or something like that."
tagline.174="<> My wife ran away with my best friend. I sure miss him. "
tagline.175="<> Never assume. It makes an 'ass' out of 'u' and 'me'. "
tagline.176="<> Never do card tricks for the group you play poker with."
tagline.177="<> Never hit a man with glasses. Use your fist!"
tagline.178="<> Never play leapfrog with a Unicorn"
tagline.179="<> Never run after buses or women: you'll always get left behind."
tagline.180="<> Never trust anything that bleeds for five days and doesn't die. "
tagline.181="<> Never try to teach a pig to sing, You waste your time and only annoys the pig."
tagline.182="<> Never underestimate the power of stupid people in large groups"
tagline.183="<> Never wrestle with a pig. You get dirty and the pig enjoys it."
tagline.184="<> Next time wave all of your fingers."
tagline.185="<> Nice perfume. Must you marinate in it?"
tagline.186="<> No one is listening until you make a mistake."
tagline.187="<> No radio - Already stolen."
tagline.188="<> No sense being pessimistic. It wouldn't work anyway."
tagline.189="<> Not all men are annoying. Some are dead."
tagline.190="<> Nothing is fool-proof to a sufficiently talented fool."
tagline.191="<> Nurses call all the SHOTS"
tagline.192="<> OK, so what's the speed of dark?"
 pick=random(1, tagline.0)
 ListMail.i.!b=ListMail.i.!b||'0d0a'x||tagline.pick
end
call ParseHTML Globals.!WMPath||"header.wm",1
if Globals.!stat2<>""&Globals.!EmailReplyTo<>"" then
 call ParseHTML Globals.!WMPath||"reply.wm"
else
 call ParseHTML Globals.!WMPath||"composeemail.wm"
call ParseHTML Globals.!WMPath||"footer.wm"
exit

NewUser: procedure expose Globals.
Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
username=substr(Globals.!stat2,3)
parse value Globals.!stat3 with "e=" emailid "&d=" domain "&p=" password
if username=""|emailid=""|domain=""|password="" then call NewUserScreen "One or more fields are incomplete."
if length(password)<4 then call NewUserScreen "Your password must be atleast 4 characters long."
if length(emailid)<4|length(emailid)>8 then call NewUserScreen "Your email ID must be between 4 and 8 characters long."
if DATATYPE(emailid,'L')=0|pos(":",username)>0|pos(":",domain)>0|pos(":",password)>0|pos(" ",password)>0 then call NewUserScreen "Illegal character detected."
call ConnectManager
call SendData "4"||":"||username||":"||emailid||":"||domain||":"||password||":"||Globals.!clientIP||":"||'0d0a'x
call ReceiveData
rc=SockSoClose(socket)
if rc=-1 then call NewUserScreen "New users are not allowed."
if pos("[WebManager2]",newData)>0 then do
 rc=substr(newData,15,1)
 if rc=2 then call NewUserScreen "Email ID already exists."
 if rc=1 then do
  call ParseHTML Globals.!WMPath||"newuser-thankyou.wm",1
  exit
 end
 call NewUserScreen "User registration rejected."
end
call SysSleep 6
call NewUserScreen "New users are not allowed."
exit

NewUserScreen: procedure expose Globals.
Globals.!ServerErr=ARG(1)
call ParseHTML Globals.!WMPath||"newuser.wm",1
exit

ParseHTML: procedure expose Globals. i ListMail.
findstring.1="*!WMVERSION!*:"||Globals.!myinfo
findstring.2="*!WMUSER!*:"||Globals.!user
findstring.3="*!WMPASS!*:"||Globals.!pazz
findstring.4="*!WMFILENAME!*:"||Globals.!myself
findstring.5="*!WMEMAILNUM!*:"||i
findstring.6="*!WMEMAILFROM!*:"||ListMail.i.!From
findstring.7="*!WMEMAILSUBJECT!*:"||ListMail.i.!Subject
findstring.8="*!WMEMAILDATE!*:"||ListMail.i.!Date
findstring.9="*!WMEMAILBODY!*:"||ListMail.i.!b
findstring.10="*!WMEMAILTABLE!*:"||Globals.!ListTable
findstring.11="*!SERVERERROR!*:"||Globals.!ServerErr
findstring.12="*!WMATTACHMENT!*:"||Globals.!ContentType
findstring.13="*!WMEMAILPRIORITY!*:"||Globals.!Priority
findstring.14="*!WMAUTHID!*:"||Globals.!AuthID
findstring.15="*!WMATTACHMENTSTABLE!*:"||Globals.!AttachmentsTable
findstring.16="*!WMATTACHFILE!*:"||Globals.!AttachFile
findstring.17="*!WMJUMPTABLE!*:"||Globals.!JumpTable
findstring.18="*!WMJUMPPAGE!*:"||Globals.!JumpPage
findstring.19="*!WMPREVEMAILNUM!*:"||Globals.!PrevEmailNum
findstring.20="*!WMNEXTEMAILNUM!*:"||Globals.!NextEmailNum
findstring.21="*!WMEMAILCC!*:"||ListMail.i.!Cc
findstring.22="*!WMEMAILREPLYTO!*:"||Globals.!EmailReplyTo
if pos("WEBMAIL2PAGE=",Globals.!Cookie)>0 then findstring.23="*!WMPAGE!*:"||substr(Globals.!Cookie,pos("WEBMAIL2PAGE=",Globals.!Cookie)+13)
else findstring.23="*!WMPAGE!*:1"
findstring.24="*!WMTOTALSIZE!*:"||Globals.!totalsize
findstring.25="*!WMADDRBTABLE!*:"||Globals.!AddrTable
findstring.26="*!WMADDRBALIAS!*:"||Globals.!AddrAlias
findstring.27="*!WMADDRBNAME!*:"||Globals.!AddrName
findstring.28="*!WMADDREMAIL!*:"||Globals.!AddrEmail
findstring.29="*!WMFULLFROM!*:"||ListMail.i.!FullFrom
findstring.30="*!WMCHARSET!*:"||Globals.!CharSet
findstring.31="*!WMSIGNATURE!*:"||Globals.!Sign
findstring.0=31
if ARG(2)=1 then do
 say 'Content-type: text/html; charset='||Globals.!CharSet
 say "Cache-Control: private"
 say "Pragma: no-cache"
 say "Expires: NOW"
 if Globals.!SetCookie="SET" then say "Set-Cookie: WEBMAIL2="||Globals.!AuthID
 if symbol("Globals.!SetCookiePage")="VAR" then do
  say "Set-Cookie: WEBMAIL2PAGE="||Globals.!SetCookiePage
  findstring.23="*!WMPAGE!*:"||Globals.!SetCookiePage
 end
 say ""
end
istr=stream(arg(1),'c','open read')
if istr<>"READY:" then do
 say "Server Error: Loading .WM files"
 exit
end
istr=stream(arg(1),'c','query size')
tmp=charin(arg(1),1,istr)
do ii=1 to findstring.0
 parse value findstring.ii with tmp1 ":" tmp2
 do while pos(tmp1,tmp)>0
  tmp3=pos(tmp1,tmp)
  tmp=delstr(tmp,tmp3,length(tmp1))
  tmp=insert(tmp2,tmp,tmp3-1)
 end
end
if ARG(3)<>1 then say tmp
return tmp

ReceiveData: procedure expose socket newData
length=ARG(1)
if length="" then length=1024
r.0=1
r.1=socket
newData=""
do while pos('0d0a'x,newData)<1
 bytes=SockSelect("r.","","",10)
 if bytes>0 then bytes=SockRecv(socket,"Buffer",length)
 else bytes=-2
 if bytes<=0 then do /* Remote socket has vanished */
  if bytes=-2 then answer=-2 /* No input within timeout */
  else if bytes<0 then answer=-1 /* Receive failure */
  else answer=-1 /* Socket has closed */
  return answer
 end; else answer=0
 newData=newData||Buffer /* Append input to bufferful */
end
return answer

ReceiveDataExtended: procedure expose socket newData
length=ARG(1)
if length="" then length=1024
r.0=1
r.1=socket
newData=""
do while pos('0d0a'x||"."||'0d0a'x,newData)<1
 bytes=SockSelect("r.","","",10)
 if bytes>0 then bytes=SockRecv(socket,"Buffer",length)
 else bytes=-2
 if bytes<=0 then do /* Remote socket has vanished */
  if bytes=-2 then answer=-2 /* No input within timeout */
  else if bytes<0 then answer=-1 /* Receive failure */
  else answer=-1 /* Socket has closed */
  return answer
 end; else answer=0
 newData=newData||Buffer /* Append input to bufferful */
end
return answer

ReceiveDataSize: procedure expose socket newData
size=ARG(1)
length=ARG(2)
if length="" then length=1024
r.0=1
r.1=socket
newData=""
do while length(newData)<size
 bytes=SockSelect("r.","","",10)
 if bytes>0 then bytes=SockRecv(socket,"Buffer",length)
 else bytes=-2
 if bytes<=0 then do /* Remote socket has vanished */
  if bytes=-2 then answer=-2 /* No input within timeout */
  else if bytes<0 then answer=-1 /* Receive failure */
  else answer=-1 /* Socket has closed */
 end; else answer=0
 newData=newData||Buffer /* Append input to bufferful */
end
return answer

ReceiveEmail: procedure expose Globals. ListMail. i
if Globals.!stat2=0 then do
 say "Status: 301 Moved Permanently"
 if pos("WEBMAIL2PAGE=",Globals.!Cookie)>0 then do
  Globals.!stat2=substr(Globals.!Cookie,pos("WEBMAIL2PAGE=",Globals.!Cookie)+13)
  say 'Location: '||Globals.!myself||"?refresh&"||Globals.!stat2
 end; else say 'Location: '||Globals.!myself||"?refresh"
 say "Cache-Control: private"
 say "Pragma: no-cache"
 say "Expires: NOW"
 say ""
 exit
end
i=Globals.!stat2
call ConnectPOP
call SendData "STAT"||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ReceiveEmail: Email server couldn't get status"
end
parse value newData with . Globals.!totalmail .
if datatype(Globals.!totalmail,"N")<>1 then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ReceiveEmail: Server returned wrong value"
end
call SendData "LIST "||Globals.!stat2||'0d0a'x
call ReceiveData
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ReceiveEmail: Server couldn't list email"
end
parse value newData with . . s2 '0d0a'x
call SendData "TOP "||Globals.!stat2||" 0"||'0d0a'x
call ReceiveData 3
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ReceiveEmail: Server couldn't receive headers"
end
call ReceiveDataExtended 32768
ListMail.i.!h=newData
if pos('0d0d0a'x,ListMail.i.!h)>0 then ListMail.i.!h=ReplaceStr(ListMail.i.!h,'0d0d0a'x,'0d0a'x)
if s2<5000000 then call SendData "RETR "||Globals.!stat2||'0d0a'x
else do
 incomplete=1
 call SendData "TOP "||Globals.!stat2||" 200"||'0d0a'x
end
call ReceiveData 3
if substr(newData,1,3)<>"+OK" then do
 call SendData "QUIT"||'0d0a'x
 call ErrorScreen 2,"ReceiveEmail: Server couldn't retrieve email body"
end
call ReceiveDataSize s2,32768
ListMail.i.!b=newData
if length(ListMail.i.!b)=8 then ListMail.i.!b="X-Junkmail: Yes"||'0d0a'x||'0d0a'x||"JunkMail: This email has been detected as junk mail."||'0d0a'x||"If this message has incorrectly been identified as junk, please forward to notjunk@junkspy.com"||ListMail.i.!b
call SendData "QUIT"||'0d0a'x
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 3,"ReceiveEmail: Error on SockSoClose"
ListMail.i.!b=substr(ListMail.i.!b,pos('0d0a'x||'0d0a'x,ListMail.i.!b)+4)
ListMail.i.!b=substr(ListMail.i.!b,1,lastpos('0d0a'x||"."||'0d0a'x,ListMail.i.!b)+1)
if arg(1)=3 then do
 call ScanHeaders 3
 if qpyes=1 then ListMail.i.!b=RXdeQuoted(ListMail.i.!b)
 if htmlyes=1 then ListMail.i.!b=Html2Txt(ListMail.i.!b)
 tmp=1
 ListMail.i.!b=insert( ">",ListMail.i.!b)
 do while pos('0d0a'x,ListMail.i.!b,tmp)>0
  tmp=pos('0d0a'x,ListMail.i.!b,tmp)+1
  ListMail.i.!b=insert( ">",ListMail.i.!b,tmp)
 end
 ListMail.i.!b=insert("On "||ListMail.i.!Date||", "||ListMail.i.!From||" wrote:"||'0d0a'x||'0d0a'x,ListMail.i.!b)
 return
end; else if arg(1)=4 then return
else do
 call ScanHeaders 2
 if qpyes=1 then ListMail.i.!b=RXdeQuoted(ListMail.i.!b)
 if htmlyes=1 then ListMail.i.!b=Html2Txt(ListMail.i.!b)
 if ListMail.i.!Priority="High" then Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-high.wm",0,1)||'0d0a'x
 else if ListMail.i.!Priority="Low" then Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-low.wm",0,1)||'0d0a'x
 else Globals.!Priority=ParseHTML(Globals.!WMPath||"priority-normal.wm",0,1)||'0d0a'x
 call ParseHTML Globals.!WMPath||"header.wm",1
 Globals.!AttachmentsTable=""
 if ListMail.i.!ContentType="YES" then do
  Globals.!ContentType=ParseHTML(Globals.!WMPath||"attachment-yes.wm",0,1)||'0d0a'x
  do iz=1 to Globals.!AttachFiles.0
   Globals.!AttachFile=Globals.!AttachFiles.iz
   Globals.!AttachmentsTable=Globals.!AttachmentsTable||ParseHTML(Globals.!WMPath||"attachment-table.wm",0,1)||'0d0a'x
  end
 end; else do
  Globals.!ContentType=ParseHTML(Globals.!WMPath||"attachment-no.wm",0,1)||'0d0a'x
  Globals.!AttachmentsTable=Globals.!ContentType
 end
 if Globals.!stat2>1 then Globals.!PrevEmailNum=Globals.!stat2-1
 else Globals.!PrevEmailNum=0
 if Globals.!stat2>=Globals.!totalmail then Globals.!NextEmailNum=0
 else Globals.!NextEmailNum=Globals.!stat2+1
 if incomplete=1 then ListMail.i.!b=ListMail.i.!b||'0d0a'x||"*************************************"||'0d0a'x||"The rest of the email body has been"||'0d0a'x||"removed because it was too big to fit"||'0d0a'x||"*************************************"||'0d0a'x
 call ParseHTML Globals.!WMPath||"reademail.wm"
 call ParseHTML Globals.!WMPath||"footer.wm"
end
exit

ReplaceStr: procedure
tmp1=ARG(1)
tmp2=ARG(2)
tmp3=ARG(3)
do forever
 iz=pos(tmp2,tmp1)
 if iz<1 then leave
 tmp=substr(tmp1,1,iz-1)
 tmpp=substr(tmp1,iz+length(tmp2),length(tmp1)-iz+length(tmp2))
 tmp1=tmp||tmp3||tmpp
end
return tmp1

ResolveEmails: procedure expose Globals.
sendto=ARG(1)
book=AddrScreen(1)
if pos(" ",sendto)>0 then do
  tmp1=sendto
  sendto=""
  do while length(tmp1)>0
   tmpemailfound=0
   tmp2=book
   parse value tmp1 with tmpemail tmp1
   do while pos(":",tmp2)>0
    parse value tmp2 with AddrAlias ":" AddrName ":" AddrEmail '0d0a'x tmp2
    if translate(tmpemail)=translate(AddrAlias)|translate(tmpemail)=translate(AddrName) then do
     tmpemailfound=1
     leave
    end
   end
   if tmpemailfound=1 then sendto=sendto||" "||AddrEmail
   else sendto=sendto||" "||tmpemail
  end
  sendto=space(sendto)
end; else do
 do while pos(":",book)>0
  parse value book with AddrAlias ":" AddrName ":" AddrEmail '0d0a'x book
  if translate(sendto)=translate(AddrAlias)|translate(sendto)=translate(AddrName) then sendto=AddrEmail
 end
end
return sendto

ScanHeaders: procedure expose Globals. i ListMail. qpyes htmlyes
ListMail.i.!h=translate(ListMail.i.!h," ",'09'x)
poz=pos('0d0a'x,ListMail.i.!h)+2
do while poz<length(ListMail.i.!h)
 rc=substr(ListMail.i.!h,poz,1)
 if rc=" " then ListMail.i.!h=substr(ListMail.i.!h,1,poz-3)||" "||space(substr(ListMail.i.!h,poz+1))
 poz=pos('0d0a'x,ListMail.i.!h,poz)+2
end
h1=translate(ListMail.i.!h)
if pos('0d0a'x||"FROM:",h1)>0 then do
 tmp1=pos('0d0a'x||"FROM:",h1)+7
 tmp2=pos('0d0a'x,h1,tmp1)
 tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
 if pos(" ",tmp3)<1 then do
  ListMail.i.!FullFrom=RXB64encode(tmp3)
  if pos("<",tmp3)>0&pos(">",tmp3)>0 then parse value tmp3 with . "<" tmp3 ">" .
 end; else if arg(1)=3 then do
  if pos("<",tmp3)>0&pos(">",tmp3)>0 then parse value tmp3 with . "<" tmp3 ">" .
  else tmp3=substr(tmp3,lastpos(" ",tmp3)+1)
 end; else do
  ListMail.i.!FullFrom=RXB64encode(tmp3)
  if pos('"',tmp3)>0 then parse value tmp3 with . '"' tmp3 '"' .
  else parse value tmp3 with tmp3 " " .
  if pos("=?",tmp3)=1 then do
   parse value tmp3 with . "?" . "?" . "?" tmp3 "?" .
   tmp3=RXdeQuoted(tmp3)
  end
 end
 ListMail.i.!From=space(tmp3)
end; else ListMail.i.!From=""
if pos('0d0a'x||"SUBJECT:",h1)>0 then do
 tmp1=pos('0d0a'x||"SUBJECT:",h1)+10
 tmp2=pos('0d0a'x,h1,tmp1)
 tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
 if pos("=?",tmp3)=1 then do
  parse value tmp3 with . "?" . "?" . "?" tmp3 "?" .
  tmp3=RXdeQuoted(tmp3)
 end
 if arg(1)=3&pos("RE:",translate(tmp3))<1 then ListMail.i.!Subject="Re: "||tmp3
 else do
  if pos("<",tmp3)>0 then tmp3=ReplaceStr(tmp3,"<","&lt;")
  if pos(">",tmp3)>0 then tmp3=ReplaceStr(tmp3,">","&gt;")
  ListMail.i.!Subject=tmp3
 end
end; else ListMail.i.!Subject=""
if pos('0d0a'x||"DATE:",h1)>0 then do
 tmp1=pos('0d0a'x||"DATE:",h1)+7
 ListMail.i.!Date=space(substr(ListMail.i.!h,tmp1,17))
end; else ListMail.i.!Date=""
if pos('0d0a'x||"PRIORITY:",h1)>0 then do
 tmp1=pos('0d0a'x||"PRIORITY:",h1)+11
 tmp2=pos('0d0a'x,h1,tmp1)
 tmp3=space(substr(h1,tmp1,tmp2-tmp1))
 if tmp3="HIGH" then ListMail.i.!Priority="High"
 else if tmp3="LOW" then ListMail.i.!Priority="Low"
 else ListMail.i.!Priority="Normal"
end; else ListMail.i.!Priority="Normal"
if arg(1)=1 then do
 if pos('0d0a'x||"CONTENT-TYPE:",h1)>0 then do
  tmp1=pos('0d0a'x||"CONTENT-TYPE:",h1)+15
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
  if pos("MULTIPART/MIXED;",translate(tmp3))>0 then ListMail.i.!ContentType="YES"
 end
end
if arg(1)=2|arg(1)=3 then do
 if pos('0d0a'x||"CONTENT-TRANSFER-ENCODING:",h1)>0 then do
  tmp1=pos('0d0a'x||"CONTENT-TRANSFER-ENCODING:",h1)+28
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
  if pos("QUOTED-PRINTABLE",translate(tmp3))>0 then qpyes=1
 end
 if pos('0d0a'x||"CONTENT-TYPE:",h1)>0 then do
  tmp1=pos('0d0a'x||"CONTENT-TYPE:",h1)+15
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
  if pos("TEXT/HTML",translate(tmp3))>0 then htmlyes=1
  if pos("CHARSET=",translate(tmp3))>0 then do
   tmp1=pos("CHARSET=",translate(tmp3))+8
   Globals.!CharSet=substr(tmp3,tmp1)
   if pos('"',Globals.!CharSet)>0 then parse value Globals.!CharSet with '"' Globals.!CharSet '"'
  end
  if pos("MULTIPART/MIXED;",translate(tmp3))>0|pos("MULTIPART/ALTERNATIVE;",translate(tmp3))>0 then do
   boundary=substr(tmp3,pos("BOUNDARY=",translate(tmp3))+9)
   if pos('"',boundary)>0 then boundary=substr(boundary,2,length(boundary)-2)
   boundary="--"||boundary
   if pos("MULTIPART/MIXED;",translate(tmp3))>0&arg(1)<>3 then do
    pozlength=1
    zi=0
    do while pos(boundary||'0d0a'x,ListMail.i.!b,pozlength)>0
     poz=pos(boundary||'0d0a'x,ListMail.i.!b,pozlength)
     pozlength=pos('0d0a'x||'0d0a'x,ListMail.i.!b,poz)+4
     headerz=substr(ListMail.i.!b,poz,pozlength-poz)
     if pos(" text",headerz)<1 then do
      if pos("name=",headerz)>0 then do
       zi=zi+1
       parse value headerz with . "name=""" Globals.!AttachFiles.zi """" .
      end; else Globals.!AttachFiles.zi="unknown"
     end
    end
    Globals.!AttachFiles.0=zi
    if Globals.!AttachFiles.0>0 then ListMail.i.!ContentType="YES"
   end
   poz=pos(boundary||'0d0a'x,ListMail.i.!b,1)
   pozlength=pos('0d0a'x||'0d0a'x,ListMail.i.!b,poz)+4
   pozend=pos(boundary,ListMail.i.!b,pozlength)-1
   call ScanSubHeaders substr(ListMail.i.!b,poz,pozlength-poz)
   ListMail.i.!b=substr(ListMail.i.!b,pozlength,pozend-pozlength)
  end; else do
   if pos("CONTENT-TRANSFER-ENCODING: QUOTED-PRINTABLE",h1)>0 then qpyes=1
  end
 end
end
if arg(1)=3 then do
 if pos('0d0a'x||"REPLY-TO:",h1)>0 then do
  tmp1=pos('0d0a'x||"REPLY-TO:",h1)+11
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
  if pos("<",tmp3)>0&pos(">",tmp3)>0 then parse value tmp3 with . "<" tmp3 ">" .
  else if pos(" ",tmp3)>0 then tmp3=substr(tmp3,lastpos(" ",tmp3)+1)
  if tmp3<>ListMail.i.!From then do
   Globals.!EmailReplyTo=ListMail.i.!From
   ListMail.i.!From=space(tmp3)
  end
 end
 if pos('0d0a'x||"CC:",h1)>0 then do
  tmp1=pos('0d0a'x||"CC:",h1)+5
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(ListMail.i.!h,tmp1,tmp2-tmp1))
  if pos("<",tmp3)>0&pos(">",tmp3)>0 then parse value tmp3 with . "<" tmp3 ">" .
  else if pos(" ",tmp3)>0 then tmp3=substr(tmp3,lastpos(" ",tmp3)+1)
  ListMail.i.!Cc=space(tmp3)
 end; else ListMail.i.!Cc=""
end
return

ScanSubHeaders: procedure expose Globals. i ListMail. qpyes htmlyes
subheader=arg(1)
subheader=translate(subheader," ",'09'x)
poz=pos('0d0a'x,subheader)+2
do while poz<length(subheader)
 rc=substr(subheader,poz,1)
 if rc=" " then subheader=substr(subheader,1,poz-3)||" "||space(substr(subheader,poz+1))
 poz=pos('0d0a'x,subheader,poz)+2
end
h1=translate(subheader)
if pos('0d0a'x||"CONTENT-TYPE:",h1)>0 then do
 tmp1=pos('0d0a'x||"CONTENT-TYPE:",h1)+15
 tmp2=pos('0d0a'x,h1,tmp1)
 tmp3=space(substr(subheader,tmp1,tmp2-tmp1))
 if pos("TEXT/HTML",translate(tmp3))>0 then htmlyes=1
 if pos("CHARSET=",translate(tmp3))>0 then do
  tmp1=pos("CHARSET=",translate(tmp3))+8
  Globals.!CharSet=substr(tmp3,tmp1)
  if pos('"',Globals.!CharSet)>0 then parse value Globals.!CharSet with '"' Globals.!CharSet '"'
 end
 if pos('0d0a'x||"CONTENT-TRANSFER-ENCODING:",h1)>0 then do
  tmp1=pos('0d0a'x||"CONTENT-TRANSFER-ENCODING:",h1)+28
  tmp2=pos('0d0a'x,h1,tmp1)
  tmp3=space(substr(subheader,tmp1,tmp2-tmp1))
  if pos("QUOTED-PRINTABLE",translate(tmp3))>0 then qpyes=1
 end
end
return

SendData: procedure expose socket
call SockSend socket,ARG(1)
return

SignScreen: procedure expose Globals.
Globals.!ServerErr=""
Globals.!Sign=""
if Globals.!stat1="signaturesave=1" then do
 parse value Globals.!querystring with . "&returnto=" Globals.!stat2 "&s=" Globals.!Sign
 if length(Globals.!Sign)>250 then Globals.!ServerErr="Too many characters. Max size is 250."
 else do
  call ConnectManager
  Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
  if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
  cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
  call SendData "9:"||cookie||":"||Globals.!clientIP||":"||Globals.!Sign||":"||'0d0a'x
  call ReceiveData
  if substr(newData,1,1)=1 then Globals.!ServerErr="Signature saved"
  else if substr(newData,1,1)=2 then Globals.!ServerErr="Signature can't be saved"
 end
 if Globals.!stat2>0 then do
  Globals.!stat3=""
  call ReceiveEmail
 end
 Globals.!stat2=""
 Globals.!stat3=""
end
i=0
call ConnectManager
Globals.!clientIP=value("REMOTE_ADDR",,'ENVIRONMENT')
if Globals.!clientIP="" then call ErrorScreen 1,"CheckLogon: Can't detect your client"
cookie=substr(Globals.!Cookie,pos("WEBMAIL2=",Globals.!Cookie)+9,33)
call SendData "8:"||cookie||":"||Globals.!clientIP||":"||'0d0a'x
call ReceiveDataExtended 32768
Globals.!Sign=substr(newData,1,lastpos(".",newData)-1)
rc=SockSoClose(socket)
if rc=-1 then call ErrorScreen 1,"CheckLogon: Error on SockSoClose"
if ARG(1)=1 then return Globals.!Sign
call ParseHTML Globals.!WMPath||"header.wm",1
call ParseHTML Globals.!WMPath||"signature.wm"
call ParseHTML Globals.!WMPath||"footer.wm"
exit

URLDecode: procedure
line=translate(ARG(1)," ","+")
lineLen=length(line)
newLine=''
i=1
do while i<=lineLen
 c=substr(line,i,1)
 if c\='%' then newLine=newLine||c
 else if i+2<=lineLen then do
  newLine= newLine||x2c(substr(line,i+1,2))
  i=i+2
 end
 i=i+1
end
return newLine
/* call charout "c:\tcpip\web2\cgi-bin\debug.txt",tmp */

UserLoginScreen: procedure expose Globals.
Globals.!SetCookie="SET"
Globals.!AuthID=""
Globals.!SetCookiePage=""
call ParseHTML Globals.!WMPath||"userlogin.wm",1
exit

